/***********************************************************************
 *                    libosa - OS and Stream Agent                     *
 *              Copyright (C) 2001,2002 Michael Brownlow               *
 *                                                                     *
 * This program is free software; you can redistribute it and/or modify*
 * it under the terms of the GNU General Public License as published by*
 * the Free Software Foundation; either version 2 of the License, or   *
 * (at your option) any later version.                                 *
 *                                                                     *
 * This program is distributed in the hope that it will be useful,     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
 * GNU General Public License for more details.                        *
 *                                                                     *
 * You should have received a copy of the GNU General Public License   *
 * along with this program; if not, write to the Free Software         *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.           *
 *                                                                     *
 * For questions and comments, please email the author at:             *
 * mike@wsmake.org                                                     *
 ***********************************************************************/
#include "osa.h"

#include <string.h>

char *osaStrDup(const char *str)
{
#if HAVE_STRDUP
  return strdup(str);
#else
  return NULL;
#endif
}

/* Just like strcat..better make sure str1 has space! */
char *osaStrCat(char *str1, const char *str2)
{
  return strcat(str1, str2);
}

int osaStrCmp(const char *str1, const char *str2)
{
  return strcmp(str1, str2);
}

char *osaStrStr(const char *haystack, const char *needle)
{
  return strstr(haystack, needle);
}

size_t osaStrLen(const char *str)
{
  return strlen(str);
}
