/* A Bison parser, made from wsParser.ypp, by GNU bison 1.75.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON	1

/* Pure parsers.  */
#define YYPURE	0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ERROR = 258,
     SCANERROR = 259,
     WORD = 260,
     INCLUDE = 261,
     REGEX = 262,
     SUBTAG = 263,
     DATA = 264,
     PART = 265,
     SCRIPT = 266,
     COMMAND = 267,
     PRINT = 268,
     STRINGL = 269,
     REGEXL = 270,
     ID = 271,
     DIR = 272,
     INTEGERL = 273,
     REALL = 274,
     HEXL = 275,
     OCTALL = 276,
     LSHIFT = 277,
     RSHIFT = 278,
     INC = 279,
     DEC = 280,
     LE = 281,
     GE = 282,
     NE = 283,
     EQ = 284,
     AND = 285,
     OR = 286,
     EXP = 287,
     UNOT = 288,
     UMINUS = 289
   };
#endif
#define ERROR 258
#define SCANERROR 259
#define WORD 260
#define INCLUDE 261
#define REGEX 262
#define SUBTAG 263
#define DATA 264
#define PART 265
#define SCRIPT 266
#define COMMAND 267
#define PRINT 268
#define STRINGL 269
#define REGEXL 270
#define ID 271
#define DIR 272
#define INTEGERL 273
#define REALL 274
#define HEXL 275
#define OCTALL 276
#define LSHIFT 277
#define RSHIFT 278
#define INC 279
#define DEC 280
#define LE 281
#define GE 282
#define NE 283
#define EQ 284
#define AND 285
#define OR 286
#define EXP 287
#define UNOT 288
#define UMINUS 289




/* Copy the first part of user declarations.  */
#line 1 "wsParser.ypp"

/***********************************************************************
 *         libwsmake - Core functionality library of wsmake            *
 *        Copyright (C) 1999,2000,2001,2002 Michael Brownlow           *
 *                                                                     *
 * This program is free software; you can redistribute it and/or modify*
 * it under the terms of the GNU General Public License as published by*
 * the Free Software Foundation; either version 2 of the License, or   *
 * (at your option) any later version.                                 *
 *                                                                     *
 * This program is distributed in the hope that it will be useful,     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
 * GNU General Public License for more details.                        *
 *                                                                     *
 * You should have received a copy of the GNU General Public License   *
 * along with this program; if not, write to the Free Software         *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.           *
 *                                                                     *
 * For questions and comments, please email the author at:             *
 * mike@wsmake.org                                                     *
 ***********************************************************************/
#include <stdio.h>

#include "wsLoader.h"
#include "wsSite.h"
#include "osa.h"

extern int yylex(void);
void yyerror(char *);

extern char *yytext;

int ws_tmp = 0;

using namespace wsmake;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#ifndef YYSTYPE
#line 40 "wsParser.ypp"
typedef union {
	char			*Tstring;
	wsmake::ast		*Tast;
	wsmake::ast_list	*Tast_list;
} yystype;
/* Line 193 of /usr/share/bison/yacc.c.  */
#line 186 "wsParser.cpp"
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif

#ifndef YYLTYPE
typedef struct yyltype
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} yyltype;
# define YYLTYPE yyltype
# define YYLTYPE_IS_TRIVIAL 1
#endif

/* Copy the second part of user declarations.  */


/* Line 213 of /usr/share/bison/yacc.c.  */
#line 207 "wsParser.cpp"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];	\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  6
#define YYLAST   118

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  53
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  21
/* YYNRULES -- Number of rules. */
#define YYNRULES  56
/* YYNRULES -- Number of states. */
#define YYNSTATES  94

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   289

#define YYTRANSLATE(X) \
  ((unsigned)(X) <= YYMAXUTOK ? yytranslate[X] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    52,     2,     2,     2,    43,    36,     2,
      50,    51,    41,    39,    48,    40,     2,    42,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    49,
      37,    33,    38,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    35,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    46,    34,    47,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    44,    45
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    15,    17,    19,    21,
      23,    25,    30,    35,    40,    42,    44,    46,    48,    53,
      55,    57,    60,    63,    65,    69,    70,    75,    78,    80,
      82,    84,    86,    88,    92,    94,    97,   100,   104,   108,
     112,   116,   120,   124,   127,   130,   133,   136,   138,   140,
     142,   144,   148,   150,   154,   157,   159
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      54,     0,    -1,    55,    -1,    56,    55,    -1,    56,    -1,
       5,    46,    68,    47,    -1,    16,    -1,    14,    -1,    12,
      -1,    15,    -1,    60,    -1,     8,    58,    33,    65,    -1,
       8,    61,    33,    65,    -1,     7,    61,    33,    65,    -1,
      21,    -1,    18,    -1,    20,    -1,    19,    -1,    58,    46,
      68,    47,    -1,    58,    -1,    57,    -1,    48,    67,    -1,
      65,    66,    -1,    65,    -1,    73,    49,    68,    -1,    -1,
      13,    58,    48,    67,    -1,    13,    58,    -1,    59,    -1,
      58,    -1,    63,    -1,    57,    -1,    72,    -1,    50,    71,
      51,    -1,    70,    -1,    40,    71,    -1,    52,    71,    -1,
      71,    39,    71,    -1,    71,    40,    71,    -1,    71,    42,
      71,    -1,    71,    41,    71,    -1,    71,    22,    71,    -1,
      71,    23,    71,    -1,    24,    57,    -1,    57,    24,    -1,
      25,    57,    -1,    57,    25,    -1,    59,    -1,    69,    -1,
      62,    -1,    72,    -1,    46,    68,    47,    -1,    64,    -1,
      57,    33,    71,    -1,    10,    64,    -1,     9,    -1,     6,
      58,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned char yyrline[] =
{
       0,    80,    80,    82,    85,    90,    96,   101,   109,   117,
     120,   125,   128,   131,   136,   139,   142,   145,   150,   158,
     159,   162,   165,   166,   169,   170,   173,   176,   181,   182,
     183,   184,   185,   189,   190,   191,   194,   197,   200,   203,
     206,   209,   212,   217,   220,   223,   226,   231,   232,   233,
     234,   235,   239,   242,   245,   248,   249
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ERROR", "SCANERROR", "WORD", "INCLUDE", 
  "REGEX", "SUBTAG", "DATA", "PART", "SCRIPT", "COMMAND", "PRINT", 
  "STRINGL", "REGEXL", "ID", "DIR", "INTEGERL", "REALL", "HEXL", "OCTALL", 
  "LSHIFT", "RSHIFT", "INC", "DEC", "LE", "GE", "NE", "EQ", "AND", "OR", 
  "EXP", "'='", "'|'", "'^'", "'&'", "'<'", "'>'", "'+'", "'-'", "'*'", 
  "'/'", "'%'", "UNOT", "UMINUS", "'{'", "'}'", "','", "';'", "'('", 
  "')'", "'!'", "$accept", "root", "site_list", "site", "id", "string", 
  "command", "regexl", "regex", "subtag", "number", "dblock", "arg", 
  "arg_", "arg_list", "exp_seq", "print", "rvalue_t", "rvalue", "prepost", 
  "exp", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    61,   124,    94,    38,    60,    62,    43,
      45,    42,    47,    37,   288,   289,   123,   125,    44,    59,
      40,    41,    33
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    53,    54,    55,    55,    56,    57,    58,    59,    60,
      61,    62,    62,    62,    63,    63,    63,    63,    64,    65,
      65,    66,    67,    67,    68,    68,    69,    69,    70,    70,
      70,    70,    70,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    72,    72,    72,    72,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     1,     4,     1,     1,     1,     1,
       1,     4,     4,     4,     1,     1,     1,     1,     4,     1,
       1,     2,     2,     1,     3,     0,     4,     2,     1,     1,
       1,     1,     1,     3,     1,     2,     2,     3,     3,     3,
       3,     3,     3,     2,     2,     2,     2,     1,     1,     1,
       1,     3,     1,     3,     2,     1,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     2,     4,    25,     1,     3,     0,     0,
       0,    55,     0,     8,     0,     7,     6,     0,     0,    25,
       0,     0,    47,    49,    52,     0,    48,    50,     0,    56,
       9,    10,     0,     0,     0,    54,    27,    43,    45,     0,
      44,    46,     0,    25,     5,    25,     0,     0,     0,     0,
      51,    15,    17,    16,    14,     0,     0,     0,    31,    29,
      28,    30,    34,    53,    32,     0,    24,    20,    19,    13,
      11,    12,    23,    26,    35,     0,    36,     0,     0,     0,
       0,     0,     0,    18,     0,    22,    33,    41,    42,    37,
      38,    40,    39,    21
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     2,     3,     4,    58,    59,    60,    31,    32,    23,
      61,    24,    72,    85,    73,    25,    26,    62,    63,    64,
      28
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -34
static const yysigned_char yypact[] =
{
       7,   -33,    31,   -34,     7,    47,   -34,   -34,    33,    43,
     -13,   -34,    33,   -34,    33,   -34,   -34,    46,    46,    47,
      12,    20,   -34,   -34,   -34,    39,   -34,   -34,    41,   -34,
     -34,   -34,    68,    69,    70,   -34,    58,   -34,   -34,    61,
     -34,   -34,    64,    47,   -34,    47,   -10,   -10,   -10,   -10,
     -34,   -34,   -34,   -34,   -34,    64,    64,    64,    40,   -34,
     -34,   -34,   -34,    -7,   -34,    63,   -34,   -34,   -34,   -34,
     -34,   -34,    65,   -34,   -34,   -12,   -34,    64,    64,    64,
      64,    64,    64,   -34,   -10,   -34,   -34,   -16,   -16,    28,
      28,   -34,   -34,   -34
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -34,   -34,   105,   -34,     3,    -5,    62,   -34,   101,   -34,
     -34,   100,   -29,   -34,    34,    49,   -34,   -34,    18,    72,
     -34
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, parse error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      21,    15,    30,    29,    15,    33,    16,    21,    20,    36,
      77,    78,     1,     5,    21,    77,    78,    69,    70,    71,
      37,    38,    20,    79,    80,    81,    82,    79,    80,    81,
      82,     6,    79,    80,    81,    82,    40,    41,    21,    86,
      21,    68,    68,    68,    68,    42,    20,    15,    20,    67,
      67,    67,    67,     8,     9,    10,    11,    12,    30,    13,
      14,    15,    16,    16,    40,    41,    43,    22,    39,    81,
      82,    17,    18,    74,    75,    76,    13,    27,    15,    68,
      16,    22,    51,    52,    53,    54,    44,    67,    17,    18,
      45,    27,    65,    19,    66,    87,    88,    89,    90,    91,
      92,    46,    47,    48,    55,    22,    49,    22,    50,     7,
      83,    34,    35,    84,    56,    27,    57,    27,    93
};

static const unsigned char yycheck[] =
{
       5,    14,    15,     8,    14,    10,    16,    12,     5,    14,
      22,    23,     5,    46,    19,    22,    23,    46,    47,    48,
      17,    18,    19,    39,    40,    41,    42,    39,    40,    41,
      42,     0,    39,    40,    41,    42,    24,    25,    43,    51,
      45,    46,    47,    48,    49,    33,    43,    14,    45,    46,
      47,    48,    49,     6,     7,     8,     9,    10,    15,    12,
      13,    14,    16,    16,    24,    25,    46,     5,    19,    41,
      42,    24,    25,    55,    56,    57,    12,     5,    14,    84,
      16,    19,    18,    19,    20,    21,    47,    84,    24,    25,
      49,    19,    43,    46,    45,    77,    78,    79,    80,    81,
      82,    33,    33,    33,    40,    43,    48,    45,    47,     4,
      47,    10,    12,    48,    50,    43,    52,    45,    84
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     5,    54,    55,    56,    46,     0,    55,     6,     7,
       8,     9,    10,    12,    13,    14,    16,    24,    25,    46,
      57,    58,    59,    62,    64,    68,    69,    72,    73,    58,
      15,    60,    61,    58,    61,    64,    58,    57,    57,    68,
      24,    25,    33,    46,    47,    49,    33,    33,    33,    48,
      47,    18,    19,    20,    21,    40,    50,    52,    57,    58,
      59,    63,    70,    71,    72,    68,    68,    57,    58,    65,
      65,    65,    65,    67,    71,    71,    71,    22,    23,    39,
      40,    41,    42,    47,    48,    66,    51,    71,    71,    71,
      71,    71,    71,    67
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)           \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#define YYLEX	yylex ()

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*-----------------------------.
| Print this symbol on YYOUT.  |
`-----------------------------*/

static void
#if defined (__STDC__) || defined (__cplusplus)
yysymprint (FILE* yyout, int yytype, YYSTYPE yyvalue)
#else
yysymprint (yyout, yytype, yyvalue)
    FILE* yyout;
    int yytype;
    YYSTYPE yyvalue;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvalue;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyout, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyout, yytoknum[yytype], yyvalue);
# endif
    }
  else
    YYFPRINTF (yyout, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyout, ")");
}
#endif /* YYDEBUG. */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
#if defined (__STDC__) || defined (__cplusplus)
yydestruct (int yytype, YYSTYPE yyvalue)
#else
yydestruct (yytype, yyvalue)
    int yytype;
    YYSTYPE yyvalue;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvalue;

  switch (yytype)
    {
      default:
        break;
    }
}



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of parse errors so far.  */
int yynerrs;


int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with.  */

  if (yychar <= 0)		/* This means end of input.  */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more.  */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

      /* We have to keep this `#if YYDEBUG', since we use variables
	 which are defined only if `YYDEBUG' is set.  */
      YYDPRINTF ((stderr, "Next token is "));
      YYDSYMPRINT ((stderr, yychar1, yylval));
      YYDPRINTF ((stderr, "\n"));
    }

  /* If the proper action on seeing token YYCHAR1 is to reduce or to
     detect an error, take that action.  */
  yyn += yychar1;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yychar1)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];



#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn - 1, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] >= 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif
  switch (yyn)
    {
        case 2:
#line 80 "wsParser.ypp"
    { }
    break;

  case 3:
#line 82 "wsParser.ypp"
    {
			wsSite_list.push_front(new wsSite(yyvsp[-1].Tast));
		}
    break;

  case 4:
#line 85 "wsParser.ypp"
    {
			wsSite_list.push_front(new wsSite(yyvsp[0].Tast));
		}
    break;

  case 5:
#line 90 "wsParser.ypp"
    {
			yyval.Tast = mk_node(Site, cons(mk_node(ExpSeq, yyvsp[-1].Tast_list), NULL));
			wsLoader_comp->endblock();
		}
    break;

  case 6:
#line 96 "wsParser.ypp"
    {
			yyval.Tast = mk_var(yytext);
		}
    break;

  case 7:
#line 101 "wsParser.ypp"
    {
			ws_tmp = strlen(yytext);
			memmove(yytext, yytext+1, ws_tmp-2); /* "(.)"; */
			yytext[ws_tmp-2] = '\0';
			yyval.Tast = mk_str(yytext);
		}
    break;

  case 8:
#line 109 "wsParser.ypp"
    {
			ws_tmp = strlen(yytext);
			memmove(yytext, yytext+1, ws_tmp-1); /* !(.); */
			yytext[ws_tmp-1] = '\0';
			yyval.Tast = mk_node(CommandExp, cons(mk_str(yytext), NULL));
		}
    break;

  case 9:
#line 117 "wsParser.ypp"
    { yyval.Tast = mk_str(yytext); }
    break;

  case 10:
#line 120 "wsParser.ypp"
    {
			yyval.Tast = mk_node(RegexExp, cons(yyvsp[0].Tast, NULL));
		}
    break;

  case 11:
#line 125 "wsParser.ypp"
    {
			yyval.Tast = mk_node(SubtagExp, cons(yyvsp[-2].Tast, cons(yyvsp[0].Tast, NULL)));
		}
    break;

  case 12:
#line 128 "wsParser.ypp"
    {
			yyval.Tast = mk_node(SubtagExp, cons(yyvsp[-2].Tast, cons(yyvsp[0].Tast, NULL)));
		}
    break;

  case 13:
#line 131 "wsParser.ypp"
    {
			yyval.Tast = mk_node(SubtagExp, cons(yyvsp[-2].Tast, cons(yyvsp[0].Tast, NULL)));
		}
    break;

  case 14:
#line 136 "wsParser.ypp"
    {
			yyval.Tast = mk_int(strtol(yytext, NULL, 8));
		}
    break;

  case 15:
#line 139 "wsParser.ypp"
    {
			yyval.Tast = mk_int(strtol(yytext, NULL, 10));
		}
    break;

  case 16:
#line 142 "wsParser.ypp"
    {
			yyval.Tast = mk_int(strtol(yytext, NULL, 16));
		}
    break;

  case 17:
#line 145 "wsParser.ypp"
    {
			yyval.Tast = mk_real(strtod(yytext, NULL));
		}
    break;

  case 18:
#line 150 "wsParser.ypp"
    {
			yyval.Tast = mk_node(DataBlock,
					cons(yyvsp[-3].Tast,
					 cons(mk_node(ExpSeq, yyvsp[-1].Tast_list), NULL)));
			wsLoader_comp->endblock();
		}
    break;

  case 19:
#line 158 "wsParser.ypp"
    { yyval.Tast = yyvsp[0].Tast; }
    break;

  case 20:
#line 159 "wsParser.ypp"
    { yyval.Tast = yyvsp[0].Tast; }
    break;

  case 21:
#line 162 "wsParser.ypp"
    { yyval.Tast_list = yyvsp[0].Tast_list; }
    break;

  case 22:
#line 165 "wsParser.ypp"
    { yyval.Tast_list = cons(yyvsp[-1].Tast, yyvsp[0].Tast_list); }
    break;

  case 23:
#line 166 "wsParser.ypp"
    { yyval.Tast_list = cons(yyvsp[0].Tast, NULL); }
    break;

  case 24:
#line 169 "wsParser.ypp"
    { yyval.Tast_list = cons(yyvsp[-2].Tast, yyvsp[0].Tast_list); }
    break;

  case 25:
#line 170 "wsParser.ypp"
    { yyval.Tast_list = NULL; }
    break;

  case 26:
#line 173 "wsParser.ypp"
    {
			yyval.Tast = mk_node(PrintExp, cons(yyvsp[-2].Tast, yyvsp[0].Tast_list));
		}
    break;

  case 27:
#line 176 "wsParser.ypp"
    {
			yyval.Tast = mk_node(PrintExp, cons(yyvsp[0].Tast, NULL));
		}
    break;

  case 33:
#line 189 "wsParser.ypp"
    { yyval.Tast = yyvsp[-1].Tast; }
    break;

  case 34:
#line 190 "wsParser.ypp"
    { yyval.Tast = yyvsp[0].Tast; }
    break;

  case 35:
#line 191 "wsParser.ypp"
    {
			yyval.Tast = mk_node(UminusExp, cons(yyvsp[0].Tast, NULL));
		}
    break;

  case 36:
#line 194 "wsParser.ypp"
    {
			yyval.Tast = mk_node(UnotExp, cons(yyvsp[0].Tast, NULL));
		}
    break;

  case 37:
#line 197 "wsParser.ypp"
    {
			yyval.Tast = mk_node(PlusExp, cons(yyvsp[-2].Tast, cons(yyvsp[0].Tast, NULL)));
		}
    break;

  case 38:
#line 200 "wsParser.ypp"
    {
			yyval.Tast = mk_node(MinusExp, cons(yyvsp[-2].Tast, cons(yyvsp[0].Tast, NULL)));
		}
    break;

  case 39:
#line 203 "wsParser.ypp"
    {
			yyval.Tast = mk_node(DivideExp, cons(yyvsp[-2].Tast, cons(yyvsp[0].Tast, NULL)));
		}
    break;

  case 40:
#line 206 "wsParser.ypp"
    {
			yyval.Tast = mk_node(TimesExp, cons(yyvsp[-2].Tast, cons(yyvsp[0].Tast, NULL)));
		}
    break;

  case 41:
#line 209 "wsParser.ypp"
    {
			yyval.Tast = mk_node(LshiftExp, cons(yyvsp[-2].Tast, cons(yyvsp[0].Tast, NULL)));
		}
    break;

  case 42:
#line 212 "wsParser.ypp"
    {
			yyval.Tast = mk_node(RshiftExp, cons(yyvsp[-2].Tast, cons(yyvsp[0].Tast, NULL)));
		}
    break;

  case 43:
#line 217 "wsParser.ypp"
    {
			yyval.Tast = mk_node(PreIncExp, cons(yyvsp[0].Tast, NULL));
		}
    break;

  case 44:
#line 220 "wsParser.ypp"
    {
			yyval.Tast = mk_node(PostIncExp, cons(yyvsp[-1].Tast, NULL));
		}
    break;

  case 45:
#line 223 "wsParser.ypp"
    {
			yyval.Tast = mk_node(PreDecExp, cons(yyvsp[0].Tast, NULL));
		}
    break;

  case 46:
#line 226 "wsParser.ypp"
    {
			yyval.Tast = mk_node(PostDecExp, cons(yyvsp[-1].Tast, NULL));
		}
    break;

  case 47:
#line 231 "wsParser.ypp"
    { yyval.Tast = yyvsp[0].Tast; }
    break;

  case 48:
#line 232 "wsParser.ypp"
    { yyval.Tast = yyvsp[0].Tast; }
    break;

  case 49:
#line 233 "wsParser.ypp"
    { yyval.Tast = yyvsp[0].Tast; }
    break;

  case 50:
#line 234 "wsParser.ypp"
    { yyval.Tast = yyvsp[0].Tast; }
    break;

  case 51:
#line 235 "wsParser.ypp"
    {
			yyval.Tast = mk_node(ExpSeq, yyvsp[-1].Tast_list);
			wsLoader_comp->endblock();
		}
    break;

  case 52:
#line 239 "wsParser.ypp"
    {
			yyval.Tast = yyvsp[0].Tast;
		}
    break;

  case 53:
#line 242 "wsParser.ypp"
    {
			yyval.Tast = mk_node(AssignExp, cons(yyvsp[-2].Tast, cons(yyvsp[0].Tast, NULL)));
		}
    break;

  case 54:
#line 245 "wsParser.ypp"
    {
			yyval.Tast = mk_node(Part, cons(yyvsp[0].Tast, NULL));
		}
    break;

  case 55:
#line 248 "wsParser.ypp"
    { yyval.Tast = mk_node(Data, NULL); }
    break;

  case 56:
#line 249 "wsParser.ypp"
    {
			if(!wsLoader_comp->push(yyvsp[0].Tast->s)) {
			  yyerror("include failure");
			} else {
			  osaPrintf(3, "Reading `%s'\n", yyvsp[0].Tast->s);
			}
		  osaFree(yyvsp[0].Tast);
		}
    break;


    }

/* Line 1016 of /usr/share/bison/yacc.c.  */
#line 1446 "wsParser.cpp"

  yyvsp -= yylen;
  yyssp -= yylen;


#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyssp > yyss)
	    {
	      YYDPRINTF ((stderr, "Error: popping "));
	      YYDSYMPRINT ((stderr,
			    yystos[*yyssp],
			    *yyvsp));
	      YYDPRINTF ((stderr, "\n"));
	      yydestruct (yystos[*yyssp], *yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yydestruct (yychar1, yylval);
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDPRINTF ((stderr, "Error: popping "));
      YYDSYMPRINT ((stderr,
		    yystos[*yyssp], *yyvsp));
      YYDPRINTF ((stderr, "\n"));

      yydestruct (yystos[yystate], *yyvsp);
      yyvsp--;
      yystate = *--yyssp;


#if YYDEBUG
      if (yydebug)
	{
	  short *yyssp1 = yyss - 1;
	  YYFPRINTF (stderr, "Error: state stack now");
	  while (yyssp1 != yyssp)
	    YYFPRINTF (stderr, " %d", *++yyssp1);
	  YYFPRINTF (stderr, "\n");
	}
#endif
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 259 "wsParser.ypp"


void yyerror(char *topic)
{
  wsLoader_comp->printError(e_Parse, "%s: `%s'", topic, yytext);
}

